#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <time.h>
#include <math.h>
#include <dos.h>

enum directions {right=1,left=2,top=3,bottom=4};
int padx,pady,ballx,bally;
unsigned char far blocks[10][4];

void grinit()
{
   int gdriver = VGA, gmode = VGAHI, errorcode;
   initgraph(&gdriver, &gmode, ".\\bgi");


   errorcode = graphresult();

   if (errorcode != grOk)
      {
      printf("Graphics error: %s\n", grapherrormsg(errorcode));
      printf("Press any key to halt:");
      getch();
      exit(1);
      }
}

void initblocks()
{
 int i,j;
 for(j=1;j<=4;j++)
  for(i=1;i<=10;i++)
   blocks[i][j]=0;
 for(j=1;j<=4;j++)
  for(i=1;i<=10;i++)
   blocks[i][j]=j+i;
}

void drawblocks()
{
 int x,y;
 for(y=0;y<=3;y++)
  for(x=0;x<=9;x++)
  {
   setfillstyle(1,blocks[x+1][y+1]);
   bar(x*64,y*40,(x*64)+64,(y*40)+40);
  }
}

void dopaddle(int x,int y)
{
 setcolor(8);
 setfillstyle(1,8);
 pieslice(x-20,y+10,0,360,10);
 pieslice(x+20,y+10,0,360,10);
 setfillstyle(1,9);
 bar(x-20,y,x+20,y+20);
}

void doball(int ballx,int bally,int color)
{
 setfillstyle(1,color);
 fillellipse(ballx,bally,5,5);
}

void movepaddle(int direction)
{
 switch(direction)
 {
  case left :
   setfillstyle(1,0);
   bar(padx-30,pady,padx+30,pady+20);
   padx=padx-20;
   setcolor(8);
   setfillstyle(1,8);
   pieslice(padx-20,pady+10,0,360,10);
   pieslice(padx+20,pady+10,0,360,10);
   setfillstyle(1,9);
   bar(padx-20,pady,padx+20,pady+20);
   setcolor(0);
   break;
  case right :
   setfillstyle(1,0);
   bar(padx-30,pady,padx+30,pady+20);
   padx=padx+20;
   setcolor(8);
   setfillstyle(1,8);
   pieslice(padx-20,pady+10,0,360,10);
   pieslice(padx+20,pady+10,0,360,10);
   setfillstyle(1,9);
   bar(padx-20,pady,padx+20,pady+20);
   setcolor(0);
   break;
 }
}

int touchblock(int ballx,int bally,int blockx, int blocky)
{
 int x1,y1,x2,y2;
 x1=(blockx*64)-64;
 x2=(blockx*64);
 y1=(blocky*40)-64;
 y2=(blocky*40);
 if((ballx==x1)&&(bally>=y1)&&(bally<=y2)) return(left);
 if((ballx==x2)&&(bally>=y1)&&(bally<=y2)) return(right);
 if((bally==y1)&&(ballx>=x1)&&(ballx<=x2)) return(top);
 if((bally==y2)&&(ballx>=x1)&&(ballx<=x2)) return(bottom);
 return(0);
}

void initscreen()
{
 int i,j;
 grinit();
 initblocks();
 drawblocks();
 dopaddle(padx,pady);
 setcolor(4);
 settextjustify(CENTER_TEXT,CENTER_TEXT);
 settextstyle(TRIPLEX_FONT, HORIZ_DIR, 10);
 outtextxy(320,240, "ARCADOID!");
 settextstyle(DEFAULT_FONT, HORIZ_DIR, 1);
 outtextxy(320,340,"Press any key to begin");
 getch();
 setcolor(0);
 settextjustify(CENTER_TEXT,CENTER_TEXT);
 settextstyle(TRIPLEX_FONT, HORIZ_DIR, 10);
 outtextxy(320,240, "ARCADOID!");
 settextstyle(DEFAULT_FONT, HORIZ_DIR, 1);
 outtextxy(320,340,"Press any key to begin");
}

void main()
{
char input;
int balldir,randdir,randdir1;
int x,y,i;
padx=320;
pady=460;
ballx=40;
bally=180;
balldir=3;
initscreen();
while(input!=27)
{
 if(kbhit())
 {
 input=getch();
 }
 switch(input)
 {
  case 75 :
   movepaddle(left);
   input='*';
   break;
  case 77 :
   movepaddle(right);
   input='*';
   break;
 }
 /* check for wall hit */
 if(ballx==5)
 {
  if(balldir==1) balldir=3;
  if(balldir==7) balldir=9;
  sound(400);
  delay(10);
  nosound();
 }
 if(ballx==635)
 {
  if(balldir==3) balldir=1;
  if(balldir==9) balldir=7;
  sound(400);
  delay(10);
  nosound();
 }
 if(bally==5)
 {
  if(balldir==9) balldir=3;
  if(balldir==7) balldir=1;
  sound(400);
  delay(10);
  nosound();
 }
 /* check for a block hit */
 for(y=1;y<=4;y++)
  for(x=1;x<=10;x++)
  {
   i=touchblock(ballx,bally,x,y);
   if((blocks[x][y]!=0)&&(i!=0))
   {
    blocks[x][y]=0;
    drawblocks();
    sound(750);
    delay(10);
    nosound();
    switch(i)
    {
     case left :
      if(balldir==3) balldir=1;
      if(balldir==9) balldir=7;
      break;
     case right :
      if(balldir==1) balldir=3;
      if(balldir==7) balldir=9;
      break;
     case top :
      if(balldir==1) balldir=7;
      if(balldir==3) balldir=9;
      break;
     case bottom :
      if(balldir==7) balldir=1;
      if(balldir==9) balldir=3;
      break;
    }
   }
  }
 /* check for paddle hit */
 if((ballx>padx-22)&&(ballx<padx+22)&&(bally==pady-6))
 {
  if(ballx>padx) balldir=9;
  if(ballx<=padx) balldir=7;
  sound(500);
  delay(10);
  nosound();
 }
 switch(balldir)
 {
  case 7 :
   delay(8);
   doball(ballx,bally,0);
   ballx-=1;
   bally-=1;
   doball(ballx,bally,15);
   break;
  case 9 :
   delay(8);
   doball(ballx,bally,0);
   ballx+=1;
   bally-=1;
   doball(ballx,bally,15);
   break;
  case 1 :
   delay(8);
   doball(ballx,bally,0);
   ballx-=1;
   bally+=1;
   doball(ballx,bally,15);
   break;
  case 3 :
   delay(8);
   doball(ballx,bally,0);
   ballx+=1;
   bally+=1;
   doball(ballx,bally,15);
   break;
  case 8 :
   delay(8);
   doball(ballx,bally,0);
   bally-=1;
   doball(ballx,bally,15);
   break;
  case 2 :
   delay(8);
   doball(ballx,bally,0);
   bally+=1;
   doball(ballx,bally,15);
   break;
  case 4 :
   delay(8);
   doball(ballx,bally,0);
   ballx-=1;
   doball(ballx,bally,15);
   break;
  case 6 :
   delay(8);
   doball(ballx,bally,0);
   ballx+=1;
   doball(ballx,bally,15);
   break;
 }
 if(bally>(pady+40))
 {
  setcolor(4);
  settextjustify(CENTER_TEXT,CENTER_TEXT);
  settextstyle(TRIPLEX_FONT, HORIZ_DIR, 8);
  outtextxy(320,240, "GAME OVER");
  settextstyle(DEFAULT_FONT, HORIZ_DIR, 1);
  outtextxy(320,340,"Press any key to quit");
  if(kbhit())
  {
  input=getch();
  input=27;
  }
 }
}
closegraph();
}